!SFX_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!SFX_LIC This is part of the SURFEX software governed by the CeCILL-C licence
!SFX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!SFX_LIC for details. version 1.
!     #########
      SUBROUTINE CLOSE_FILE_LFI(HPROGRAM,KUNIT )
!     #######################################################
!
!!****  *CLOSE_FILE_LFI* - closes files read by surface in MESOHN
!!
!!    PURPOSE
!!    -------
!!
!!**  METHOD
!!    ------
!!
!!    EXTERNAL
!!    --------
!!
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      V. Masson   *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2003 
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
#ifdef SFX_LFI
USE MODD_FMDECLAR,    ONLY : CNAMFI
#endif
USE MODD_IO_SURF_LFI, ONLY : CLUOUT_LFI
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
!
 CHARACTER(LEN=6),  INTENT(IN)  :: HPROGRAM ! main program
INTEGER,           INTENT(IN)  :: KUNIT    ! logical unit of file
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
INTEGER :: IRESP
!-------------------------------------------------------------------------------
!
!* closes the file
!  -------------------
!
IF (LHOOK) CALL DR_HOOK('CLOSE_FILE_LFI',0,ZHOOK_HANDLE)
#ifdef SFX_LFI
 CALL FMFREE(CNAMFI(KUNIT),CLUOUT_LFI,IRESP)
#endif
CLOSE(KUNIT)
IF (LHOOK) CALL DR_HOOK('CLOSE_FILE_LFI',1,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------
!
END SUBROUTINE CLOSE_FILE_LFI
