!SFX_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!SFX_LIC This is part of the SURFEX software governed by the CeCILL-C licence
!SFX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!SFX_LIC for details. version 1.
SUBROUTINE WRITE_FIELD_2D_PATCH(HSELECT,HPROGRAM,HRECFM,HCOMMENT,KP,KMASK,PFIELD_IN,KSIZE,HNAM_DIM,&
                                PWORK_WR)
!
USE MODD_TYPE_SNOW
!
USE MODD_WRITE_SURF_ATM, ONLY : LSPLIT_PATCH
!
USE MODD_SURF_PAR, ONLY : XUNDEF
!
USE MODI_UNPACK_SAME_RANK
USE MODI_WRITE_SURF
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
 CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) :: HSELECT
 CHARACTER(LEN=*), INTENT(IN) :: HPROGRAM
 CHARACTER(LEN=*), INTENT(IN) :: HRECFM
 CHARACTER(LEN=*), INTENT(IN) :: HCOMMENT
INTEGER, INTENT(IN) :: KP
INTEGER, DIMENSION(:), INTENT(IN) :: KMASK
REAL, DIMENSION(:,:), INTENT(IN) :: PFIELD_IN
INTEGER, INTENT(IN) :: KSIZE
 CHARACTER(LEN=*), INTENT(IN) :: HNAM_DIM
REAL, DIMENSION(:,:,:), OPTIONAL, INTENT(INOUT) :: PWORK_WR
!
REAL, DIMENSION(KSIZE,SIZE(PFIELD_IN,2)) :: ZWORK
 CHARACTER(LEN=12) :: YRECFM
 CHARACTER(LEN=2) :: YPAT
INTEGER :: IRESP, ILEN
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
IF (LHOOK) CALL DR_HOOK('WRITE_FIELD_2D_PATCH',0,ZHOOK_HANDLE)
!
YRECFM=ADJUSTL(HRECFM(:LEN_TRIM(HRECFM)))
 CALL UNPACK_SAME_RANK(KMASK,PFIELD_IN,ZWORK,XUNDEF)
!
IF (LSPLIT_PATCH) THEN
  !
  IF (KP/=0) THEN
    WRITE(YPAT,'(I2)') KP
    YRECFM=ADJUSTL(YRECFM(:LEN_TRIM(YRECFM)))//'P'//ADJUSTL(YPAT(:LEN_TRIM(YPAT)))
  ENDIF
  CALL WRITE_SURF(HSELECT,HPROGRAM,YRECFM,ZWORK,IRESP,HCOMMENT=HCOMMENT,HNAM_DIM=HNAM_DIM)
  !
ELSE
  !
  ILEN = LEN_TRIM(YRECFM)
  IF (YRECFM(ILEN:ILEN)=="_") YRECFM = ADJUSTL(YRECFM(:LEN_TRIM(YRECFM)))//'P'  
  IF (KP/=0) THEN
    PWORK_WR(:,:,KP) = ZWORK(:,:)
    IF ( KP==SIZE(PWORK_WR,3) ) THEN
      CALL WRITE_SURF(HSELECT,HPROGRAM,YRECFM,PWORK_WR,IRESP,HCOMMENT=HCOMMENT,HNAM_DIM=HNAM_DIM)
   ENDIF
  ELSE
    CALL WRITE_SURF(HSELECT,HPROGRAM,YRECFM,ZWORK,IRESP,HCOMMENT=HCOMMENT,HNAM_DIM=HNAM_DIM)
  ENDIF
  !
ENDIF
!
IF (LHOOK) CALL DR_HOOK('WRITE_FIELD_2D_PATCH',1,ZHOOK_HANDLE)
!
END SUBROUTINE WRITE_FIELD_2D_PATCH
