!SFX_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!SFX_LIC This is part of the SURFEX software governed by the CeCILL-C licence
!SFX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!SFX_LIC for details. version 1.
SUBROUTINE WRITE_TFIELD_1D_PATCH(HSELECT,HPROGRAM,HRECFM,HCOMMENT,KP,KMASK,TFIELD_IN,KSIZE,TPDATE_WR)
!
USE MODD_TYPE_DATE_SURF
!
USE MODD_WRITE_SURF_ATM, ONLY : LSPLIT_PATCH
!
USE MODD_SURF_PAR, ONLY : XUNDEF, NUNDEF
!
USE MODI_UNPACK_SAME_RANK
USE MODI_WRITE_SURF
!
IMPLICIT NONE
!
 CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) :: HSELECT
 CHARACTER(LEN=*), INTENT(IN) :: HPROGRAM
 CHARACTER(LEN=*), INTENT(IN) :: HRECFM
 CHARACTER(LEN=*), INTENT(IN) :: HCOMMENT
INTEGER, INTENT(IN) :: KP
INTEGER, DIMENSION(:), INTENT(IN) :: KMASK
TYPE(DATE_TIME), DIMENSION(:), INTENT(IN) :: TFIELD_IN
TYPE(DATE_TIME), DIMENSION(:,:), INTENT(INOUT) :: TPDATE_WR
INTEGER, INTENT(IN) :: KSIZE
!
INTEGER, DIMENSION(SIZE(TFIELD_IN)) :: ZINT1
INTEGER, DIMENSION(KSIZE) :: ZINT2
REAL, DIMENSION(SIZE(TFIELD_IN)) :: ZINT1R
REAL, DIMENSION(KSIZE) :: ZINT2R
TYPE(DATE_TIME), DIMENSION(KSIZE) :: TZWORK
!
 CHARACTER(LEN=12) :: YRECFM
 CHARACTER(LEN=2) :: YPAT
INTEGER :: IRESP
!
YRECFM=ADJUSTL(HRECFM(:LEN_TRIM(HRECFM)))
IF (LSPLIT_PATCH) THEN
  IF (KP/=0) THEN
    WRITE(YPAT,'(I2)') KP
    YRECFM=ADJUSTL(HRECFM(:LEN_TRIM(HRECFM)))//'P'//ADJUSTL(YPAT(:LEN_TRIM(YPAT)))
  ENDIF
ENDIF
!
ZINT1 = TFIELD_IN(:)%TDATE%YEAR
 CALL UNPACK_SAME_RANK(KMASK,ZINT1,ZINT2,NUNDEF)
TZWORK(:)%TDATE%YEAR = ZINT2
ZINT1 = TFIELD_IN(:)%TDATE%MONTH 
 CALL UNPACK_SAME_RANK(KMASK,ZINT1,ZINT2,NUNDEF)
TZWORK(:)%TDATE%MONTH = ZINT2 
ZINT1 = TFIELD_IN(:)%TDATE%DAY
 CALL UNPACK_SAME_RANK(KMASK,ZINT1,ZINT2,NUNDEF)
TZWORK(:)%TDATE%DAY = ZINT2 
ZINT1R = TFIELD_IN(:)%TIME
 CALL UNPACK_SAME_RANK(KMASK,ZINT1R,ZINT2R,XUNDEF)
TZWORK(:)%TIME = ZINT2R
!
IF (LSPLIT_PATCH) THEN
  CALL WRITE_SURF(HSELECT,HPROGRAM,YRECFM,TZWORK,IRESP,HCOMMENT=HCOMMENT)
ELSE
  IF (KP/=0) THEN
    TPDATE_WR(:,KP)%TDATE%YEAR  = TZWORK(:)%TDATE%YEAR
    TPDATE_WR(:,KP)%TDATE%MONTH = TZWORK(:)%TDATE%MONTH
    TPDATE_WR(:,KP)%TDATE%DAY   = TZWORK(:)%TDATE%DAY
    TPDATE_WR(:,KP)%TIME        = TZWORK(:)%TIME
    IF ( KP==SIZE(TPDATE_WR,2) ) THEN
      CALL WRITE_SURF(HSELECT,HPROGRAM,YRECFM,TPDATE_WR,IRESP,HCOMMENT=HCOMMENT)
   ENDIF
  ELSE
    CALL WRITE_SURF(HSELECT,HPROGRAM,YRECFM,TZWORK,IRESP,HCOMMENT=HCOMMENT)
  ENDIF
ENDIF
!
END SUBROUTINE WRITE_TFIELD_1D_PATCH
